//+------------------------------------------------------------------+
//|                                                 Donchian Channel |
//+------------------------------------------------------------------+

#property  copyright "ps"
#property  link      ""
//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 2
#property  indicator_color1  Blue
#property  indicator_color2  Red
#property  indicator_width1  2
#property  indicator_width2  2

//---- indicator parameters
extern int periods=20;
extern double ATRmultiplier=2;

//---- indicator buffers
double     upper[];
double     lower[];
double     tmpupper[];
double     tmplower[];
double     trend[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   
//---- indicator buffers mapping
   IndicatorBuffers(5);
   SetIndexBuffer(0,upper);
   SetIndexBuffer(1,lower);
   SetIndexBuffer(2,tmpupper);
   SetIndexBuffer(3,tmplower);
   SetIndexBuffer(4,trend);
   
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("ATR-exit("+periods+")");
   SetIndexLabel(0,"Upper");
   SetIndexLabel(1,"Lower");
      
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| now do the dance.                           |
//+------------------------------------------------------------------+
int start()
  {
   int    i,limit;
   double atrvalue;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

//---- calculate values
   for(i=limit; i>=0; i--) 
   {
      atrvalue=(iATR(NULL,0,periods,i))*ATRmultiplier;
      tmplower[i]=iHigh(Symbol(),Period(),i+1)-atrvalue;
      tmpupper[i]=iLow(Symbol(),Period(),i+1)+atrvalue;
      if (tmplower[i]<tmplower[i+1] && Low[i]>tmplower[i+1]) tmplower[i]=tmplower[i+1]; 
      if (tmpupper[i]>tmpupper[i+1] && High[i]<tmpupper[i+1]) tmpupper[i]=tmpupper[i+1];
      trend[i]=trend[i+1];
//----      
      if(Low[i] < tmplower[i+1]) trend[i]= 1;
      if(High[i] > tmpupper[i+1]) trend[i]=-1;
      if(trend[i] >0)
        {
         upper[i]=tmpupper[i];
         lower[i]=EMPTY_VALUE;
        }
      if(trend[i] <0)
        {
         upper[i]=EMPTY_VALUE;
         lower[i]=tmplower[i];
        }

   }
   return(0);
  }